
###################### ZÁKLAD ######################

import pygame, os, random, math
from pygame.locals import *

pygame.mixer.pre_init(44100, -16, 2, 2048)
pygame.font.init()
pygame.init()

screen = pygame.display.set_mode([720, 540])
pygame.display.set_caption("PumpkinParty")

start = pygame.Surface(screen.get_size())
start.fill((0, 0, 0))
start = start.convert_alpha()
screen.blit(start, (0, 0))
pygame.display.flip()

###################### NAČÍTANIE FONTOV ######################

try:
    ghostF = pygame.font.SysFont("None", 35)
    sanityF = pygame.font.Font("fonts/HauntAOE.ttf", 40)
    casualF = pygame.font.Font("fonts/HauntAOE.ttf", 30)
    endF = pygame.font.Font("fonts/HauntAOE.ttf", 70)
except:
    raise UserWarning ("!CHYBA! Neviem nájsť font/fonty v priečinku 'fonts' :(")
ghostF.set_bold(True)

#########################################################################
###################### DEFINOVANIE FUNKCIÍ / TRIED ######################
#########################################################################

###################### PREHRÁVANIE HUDBY ######################

def playM():
    global volume
    pygame.mixer.music.set_volume(volume)
    pygame.mixer.music.play(-1)

###################### EFEKT PRÍCHODU NA SCÉNU ######################

def fadeIN(BG):
    fade = pygame.Surface((screen.get_size()))
    fade.fill((0,0,0))
    for alpha in range(0, 260, 8):
        fade.set_alpha(260-alpha)
        screen.blit(BG, (0,0))
        alles.draw(screen)
        if not(Character.human):
            screen.blit(white, (0,0))
        front.draw(screen)
        screen.blit(fade, (0,0))
        pygame.display.flip()
        pygame.time.wait(5)
    screen.blit(BG, (0,0))
    alles.draw(screen)
    if not(Character.human) and BG == BGlvl:
        screen.blit(white, (0,0))
    front.draw(screen)
    pygame.display.flip()

###################### EFEKT ODCHODU ZO SCÉNY ######################

def fadeOUT(BG): 
    fade = pygame.Surface(screen.get_size())
    fade.fill((0,0,0))
    for alpha in range(0, 260, 8):
        fade.set_alpha(alpha)
        screen.blit(BG, (0,0))
        alles.draw(screen)
        if not(Character.human) and BG == BGlvl:
            screen.blit(white, (0,0))
        front.draw(screen)
        screen.blit(fade, (0,0))
        pygame.display.flip()
        pygame.time.wait(5)

###################### TEXT S POSTUPNÝM VÝPISOM ######################

class Text(pygame.sprite.Sprite):
    texts = []
    def __init__(self, textpos, color, mess, time, speed):
       pygame.sprite.Sprite.__init__(self, self.groups)
       self.writing = True
       self.speed = speed
       self.state = 0
       self.time = time
       self.pos = textpos
       self.textpos = textpos
       self.mess = mess
       self.color = color
       self.image = pygame.Surface((720, 50))
       self.image.fill((0,0,0))
       self.rect = self.image.get_rect()
       self.rect.center = self.pos
        
    def update(self, sec):
        if self.state <= len(self.mess) and self.writing:
            text = casualF.render(self.mess[:self.state], True, self.color)
            text = text.convert_alpha()
            self.image.fill((0,0,0))
            self.image.blit(text, (0, 0))
            self.image.set_colorkey((0,0,0))
            self.image = self.image.convert_alpha()
            self.state += self.speed
        elif self.writing:
            self.state = len(self.mess)-1
            self.writing = False
            text = casualF.render(self.mess, True, self.color)
            text = text.convert_alpha()
            self.image.fill((0,0,0))
            self.image.blit(text, (0, 0))
            self.image.set_colorkey((0,0,0))
            self.image = self.image.convert_alpha()
        elif self.time < 0:
            text = casualF.render(self.mess[:self.state], True, self.color)
            text = text.convert_alpha()
            self.image.fill((0,0,0))
            self.image.blit(text, (0, 0))
            self.image.set_colorkey((0,0,0))
            self.image = self.image.convert_alpha()
            self.state -= self.speed
            if self.state < 1:
                Text.texts.remove(self)
                self.kill()
        else:
            self.time -= sec

###################### VÝZDOBA ######################

class Decoration(pygame.sprite.Sprite):
    images = []
    decorations = []
    Dtypes = [[0, 7, 0.05, "dancerH"], [8, 15, 0.05, "dancerC"], [16, 25, 0.03, "dancerA"], [26, 33, 0.05, "dancerV"],
              [34, 37, 0.1, "dancerP"], [38, 45, 0.05, "dancerZ"], [46, 51, 0.05, "dancer"], [52, 52, 1000, "legS"],
              [53, 53, 1000, "corpseA"], [54, 54, 1000, "chain"], [55, 55, 1000, "Dchain"], [56, 56, 1000, "pumpkin1"],
              [57, 57, 1000, "pumpkin2"], [58, 58, 1000, "pumpkin3"], [59, 59, 1000, "pumpkin4"], [60, 60, 1000, "Dpumpkin1"],
              [61, 61, 1000, "Dpumpkin2"], [62, 62, 1000, "Dpumpkin3"], [63, 63, 1000, "Dpumpkin4"], [64, 64, 1000, "table"],
              [65, 65, 1000, "tableD"], [66, 66, 1000, "baloons"],[67, 67, 1000, "baloons"], [68, 68, 1000, "cupO"],
              [69, 69, 1000, "cupB"], [70, 70, 1000, "cupcakes"], [71, 71, 1000, "dravers"], [72, 72, 1000, "2456"],
              [73, 73, 1000, "picture1"], [74, 74, 1000, "picture2"], [75, 75, 1000, "picture3"], [76, 76, 1000, "picture4"],
              [77, 77, 1000, "ways"], [78, 78, 1000, "Gways"], [79, 80, 1000, "pentagram"], [81, 81, 1000, "Bianca"],
              [82, 82, 1000, "Lenka"], [83, 83, 1000, "Veronika"], [84, 84, 1000, "Katka"], [85, 85, 1000, "carpet"],
              [86, 86, 1000, "4hint"]]
    
    def __init__(self, startpos, Dtype, rotate, visibility, doori = 0):
       pygame.sprite.Sprite.__init__(self, self.groups)
       self.vis = visibility
       self.pos = startpos
       self.doori = doori
       self.Dtype = Dtype
       self.Ainterval = self.Dtypes[self.Dtype][2]
       self.state = self.Dtypes[self.Dtype][0]
       self.angle = rotate
       if self.vis == 0 or (self.vis == 1 and Character.human) or (self.vis == -1 and not(Character.human)):
           self.image = Decoration.images[self.state]
       else:
           self.image = pygame.Surface((10, 10))
           self.image.fill((0,0,0))
           self.image.set_colorkey((0,0,0))
       self.image = self.image.convert_alpha()
       self.rect = self.image.get_rect()
       self.rect.center = self.pos
       
    def update(self, sec):
       if self.Dtype == 34:
           if len(Corpse.corpses) > 0 and self.rect.collidelist(Corpse.rects) != -1 and self.state == 79:
               self.image = pygame.transform.rotate(Decoration.images[self.state+1], self.angle)
               Text.texts.append(Text((660, 485), (255, 0, 0), "AETERNUM VALE!!", 3, 1))
               self.state += 1
               Door.doors[self.doori].openable = True
               fire.play()
       elif self.vis == 0 or (self.vis == 1 and Character.human) or (self.vis == -1 and not(Character.human)):
           if self.Ainterval < 0:
               self.state += 1
               if self.state > self.Dtypes[self.Dtype][1]:
                   self.state = self.Dtypes[self.Dtype][0]
               self.Ainterval = self.Dtypes[self.Dtype][2]
           elif self.Ainterval < 1000:
               self.Ainterval -= sec
           self.image = pygame.transform.rotate(Decoration.images[self.state], self.angle)
       else:
           self.image = pygame.Surface((10, 10))
           self.image.fill((0,0,0))
           self.image.set_colorkey((0,0,0))
       self.image = self.image.convert_alpha()
       self.rect = self.image.get_rect()
       self.rect.center = self.pos

###################### UKAZATEĽ PSYCHIKY ######################

class Sanity(pygame.sprite.Sprite):
    image = None
    sanity = 250
    text = sanityF.render("Psychika:", True, (180, 0, 0))
    text = text.convert_alpha()
    image = pygame.Surface((700, 50))
    image.fill((0,0,0))
    image.blit(text, (0, 5))
    pygame.draw.rect(image, (0, 250, 0), (120, 15, 500, 30))
    image.set_colorkey((0,0,0))
    image.convert_alpha()
    
    def __init__(self):
       pygame.sprite.Sprite.__init__(self, self.groups) 
       self.pos = (360, 510)
       self.image = Sanity.image
       self.rect = self.image.get_rect()
       self.rect.center = self.pos
       
    def update(self, sec):
        Sanity.image.fill((0,0,0))
        Sanity.image.blit(Sanity.text, (0, 5))
        red = 250-Sanity.sanity
        green = Sanity.sanity
        pygame.draw.rect(Sanity.image, (red, green, 0), (120, 15, round(Sanity.sanity * 2), 30))
        Sanity.image.set_colorkey((0,0,0))
        Sanity.image.convert_alpha()
        self.image = Sanity.image

###################### OKNO S OVLÁDANÍM ######################

class HintBut(pygame.sprite.Sprite):
    images = []
    opened = False
    
    def __init__(self):
       pygame.sprite.Sprite.__init__(self, self.groups) 
       self.pos = (675, 515)
       self.image = HintBut.images[0]
       self.rect = self.image.get_rect()
       self.rect.center = self.pos
       
    def update(self, sec):
        self.image = HintBut.images[0]
        self.rect = self.image.get_rect()
        self.rect.center = self.pos
        
    def hinting(self):
        global screen
        global fullscreen
        global volume
        if volume != 0:
            self.image = HintBut.images[1]
        else:
            self.image = HintBut.images[2]
        self.rect = self.image.get_rect()
        self.rect.center = (360, 270)
        front.draw(screen)
        pygame.display.flip()
        while True:
            event = pygame.event.wait()
            if event.type == pygame.QUIT:
                return 0
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1 and event.pos[0] > 686 and event.pos[0] < 710 and event.pos[1] > 500 and event.pos[1] < 530:
                click.play()
                return 0
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1 and event.pos[0] > 661 and event.pos[0] < 685 and event.pos[1] > 500 and event.pos[1] < 530:
                click.play()
                if self.image == HintBut.images[1]:
                    volume = 0
                    pygame.mixer.music.set_volume(0)
                    self.image = HintBut.images[2]
                else:
                    volume = 0.2
                    pygame.mixer.music.set_volume(0.2)
                    self.image = HintBut.images[1]
                screen.blit(self.image, (0, 0))
                pygame.display.flip()
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1 and event.pos[0] > 636 and event.pos[0] < 660 and event.pos[1] > 500 and event.pos[1] < 530:
                click.play()
                pygame.display.quit()
                if fullscreen:
                    screen = pygame.display.set_mode((720, 540))
                    fullscreen = False
                else:
                    screen = pygame.display.set_mode((740, 560),pygame.FULLSCREEN)
                    fullscreen = True
                screen.blit(BGlvl, (0, 0))
                alles.draw(screen)
                front.draw(screen)
                pygame.display.flip()

###################### OBMEDZENIE DOHĽADU ######################

class Sight(pygame.sprite.Sprite):
    images = []
    
    def __init__(self, startpos, Stype = 0):
       pygame.sprite.Sprite.__init__(self, self.groups) 
       self.pos = [0.0, 0.0]
       self.pos[0] = startpos[0] * 1.0
       self.pos[1] = startpos[1] * 1.0
       self.image = Sight.images[Stype]
       self.rect = self.image.get_rect()
       self.rect.center = self.pos
       
    def update(self, sec):
        self.pos = Character.rect.center
        self.rect.center = Character.rect.center

###################### PASŤ ######################

class Hole(pygame.sprite.Sprite):
    images = []
    rects = []
    holes = []
    escape = False
    
    def __init__(self, startpos):
       pygame.sprite.Sprite.__init__(self, self.groups)
       self.pos = [0.0, 0.0]
       self.pos[0] = startpos[0] * 1.0
       self.pos[1] = startpos[1] * 1.0
       self.image = Hole.images[0]
       self.rect = self.image.get_rect()
       self.rect.centerx = round(self.pos[0],0)
       self.rect.centery = round(self.pos[1],0)
       Hole.rects.append(self.rect)
       Hole.holes.append(self)

    def update(self, sec):
        if self.rect.colliderect(Character.rect):
            Hole.escape = True
        else:
            self.image = Hole.images[0]

    def fall(self):
        hole.play()
        Text.texts.append(Text((680, 455), (255, 255, 255), "Aaaaaa!", 2, 2))
        for i in range(5):
            self.image = Hole.images[i]
            self.rect = self.image.get_rect()
            self.rect.centerx = round(self.pos[0],0)
            self.rect.centery = round(self.pos[1],0)
            Text.texts[-1].update(0)
            screen.blit(BGlvl, (0,0))
            alles.draw(screen)
            front.draw(screen)
            pygame.display.flip()
            pygame.time.wait(30)
        pygame.time.wait(300)
        return False

###################### STENY ######################

class Wall(pygame.sprite.Sprite):
    images = []
    rects = []
    walls = []
    
    def __init__(self, startpos, rotation):
       pygame.sprite.Sprite.__init__(self, self.groups) 
       self.pos = [0.0, 0.0]
       self.pos[0] = startpos[0] * 1.0
       self.pos[1] = startpos[1] * 1.0
       self.image = Wall.images[rotation]
       self.rect = self.image.get_rect()
       self.rect.centerx = round(self.pos[0],0)
       self.rect.centery = round(self.pos[1],0)
       Wall.rects.append(self.rect)

###################### PORTÁLY PRE DUCHA ######################

class Portal(pygame.sprite.Sprite):
    images = []
    rects = []
    rectsB = []
    portals = []
    
    def __init__(self, startpos, rotation):
       pygame.sprite.Sprite.__init__(self, self.groups) 
       self.pos = [0.0, 0.0]
       self.pos[0] = startpos[0] * 1.0
       self.pos[1] = startpos[1] * 1.0
       self.image = Portal.images[(rotation)*3+2]
       self.rect = self.image.get_rect()
       self.rect.centerx = round(self.pos[0],0)
       self.rect.centery = round(self.pos[1],0)
       Portal.rects.append(self.rect)
       self.rectBig = self.rect.inflate(0, -25)
       if rotation == 0:
           self.rectBig.centery = round(self.pos[1],0)-25
       Portal.rectsB.append(self.rectBig)

    def update(self, sec):
        if not(Character.human):
            if self.rectBig.colliderect(Character.rect):
                self.image = Portal.images[(Portal.images.index(self.image)//3)*3 + 1]
            else:
                self.image = Portal.images[(Portal.images.index(self.image)//3)*3]
        else:
            self.image = Portal.images[(Portal.images.index(self.image)//3)*3 + 2]
        self.rect = self.image.get_rect()
        self.rect.centerx = round(self.pos[0],0)
        self.rect.centery = round(self.pos[1],0)

###################### DVERE ######################

class Door(pygame.sprite.Sprite):
    images = []
    rects = []
    rectsB = []
    doors = []
    
    def __init__(self, startpos, rotation, lock, escape, secret = False, code = False, hurt = False):
       pygame.sprite.Sprite.__init__(self, self.groups)
       self.escape = escape
       self.code = code
       self.hurt = hurt
       self.secret = secret
       self.pos = [0.0, 0.0]
       self.pos[0] = startpos[0] * 1.0
       self.pos[1] = startpos[1] * 1.0
       self.image = Door.images[(rotation)*2]
       self.rect = self.image.get_rect()
       self.rect.centerx = round(self.pos[0],0)
       self.rect.centery = round(self.pos[1],0)
       Door.rects.append(self.rect)
       self.rectBig = self.rect.inflate(0, -25)
       if rotation == 1:
           self.rectBig.centery = round(self.pos[1],0)-25
       Door.rectsB.append(self.rectBig)
       if lock or code:
           self.openable = False
       else:
           self.openable = True
       
    def update(self, sec):
        global pressed
        if self.rectBig.colliderect(Character.rect) and not(self.secret):
            self.image = Door.images[(Door.images.index(self.image)//2)*2 + 1]
            if self.code:
                for k in pressed:
                    if pressed.count(k) > 1:
                        pressed = [k]
                    if k != pygame.K_i and k != pygame.K_o and k != pygame.K_k and k != pygame.K_l:
                        pressed = []
                    elif pygame.K_i in pressed and pygame.K_o in pressed and pygame.K_k in pressed and pygame.K_l in pressed:
                        pip.play()
                        self.openable = True
                        pressed = []
        else:
            self.image = Door.images[(Door.images.index(self.image)//2)*2]

###################### ZÁMKY ######################

class Lock(pygame.sprite.Sprite):
    images = []
    rects = []
    locks = []
    
    def __init__(self, startpos, rotation, doori):
       pygame.sprite.Sprite.__init__(self, self.groups) 
       self.pos = [0.0, 0.0]
       self.pos[0] = startpos[0] * 1.0
       self.pos[1] = startpos[1] * 1.0
       self.image = Lock.images[(rotation)*4]
       self.rect = self.image.get_rect()
       self.rect.centerx = round(self.pos[0],0)
       self.rect.centery = round(self.pos[1],0)
       Lock.rects.append(self.rect)
       self.doori = doori
       self.on = True
       
    def update(self, sec):
        if self.on:
            self.image = Lock.images[(Lock.images.index(self.image)//4)*4]
        else:
            self.image = Lock.images[(Lock.images.index(self.image)//4)*4 + 2]
        if self.rect.colliderect(Character.rect):
            self.image = Lock.images[(Lock.images.index(self.image)//2)*2 + 1]
        else:
            self.image = Lock.images[(Lock.images.index(self.image)//2)*2]

###################### DUCHOVIA ######################

class Ghost(pygame.sprite.Sprite):
    FreeS = []
    UsedS = []
    Ginterval = 3.5
    images = []
    ghosts = []
    marked = [[], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], []]
    
    def __init__(self, startpos, gtype):
       pygame.sprite.Sprite.__init__(self, self.groups)
       self.pos = [0.0, 0.0]
       self.Ainterval = 0.0
       self.Dinterval = 0.0
       self.pos[0] = startpos[0] * 1.0
       self.pos[1] = startpos[1] * 1.0
       self.x = Corpse.end[0] - self.pos[0]
       self.y = Corpse.end[1] - self.pos[1]
       self.gtype = gtype
       self.image = Ghost.images[gtype*8].copy()
       self.letter = random.randint(0, 19)
       self.text = ghostF.render(letters[self.letter], True, (180, 0, 0))
       self.text = self.text.convert_alpha()
       self.rect = self.image.get_rect()
       self.rect.centerx = round(self.pos[0],0)
       self.rect.centery = round(self.pos[1],0)
       self.rectSmall = self.rect.inflate(-40, -40)
       self.rectSmall.centerx = round(self.pos[0],0)
       self.rectSmall.centery = round(self.pos[1],0)
       self.state = 0
       Ghost.marked[self.letter] += [self]
       Ghost.ghosts.append(self)
       
       if Corpse.end[0] == self.pos[0] and Corpse.end[1] > self.pos[1]:
           self.angle = 180
       elif Corpse.end[0] > self.pos[0] and Corpse.end[1] > self.pos[1]:
           self.angle = -(90 + math.degrees(math.atan(abs(self.y/self.x))))
       elif Corpse.end[0] > self.pos[0] and Corpse.end[1] < self.pos[1]:
           self.angle = -(math.degrees(math.atan(abs(self.x/self.y))))
       elif Corpse.end[0] < self.pos[0] and Corpse.end[1] > self.pos[1]:
           self.angle = 90 + math.degrees(math.atan(abs(self.y/self.x)))
       elif Corpse.end[0] < self.pos[0] and Corpse.end[1] < self.pos[1]:
           self.angle = math.degrees(math.atan(abs(self.x/self.y)))
            
    def update(self, sec):
        if Character.human:
            self.kill()
            
        if self.rect.collidelist(Corpse.rects) == -1:
            self.pos[0]+= self.x * sec/3
            self.pos[1] += self.y * sec/3
            self.Ainterval += sec
            if self.Ainterval > 0.03:
                self.state += 1
                if self.state >= 8:
                    self.state = 0
                self.image = pygame.transform.rotate(self.images[self.gtype*8 + self.state], self.angle)
                self.image.blit(self.text, (10, 50))
                self.Ainterval = 0.0
        else:
            self.Dinterval += sec
            self.image = self.images[self.gtype*8].copy()
            self.image.blit(self.text, (self.image.get_size()[0]//2-8, 0))
            if self.Dinterval > 1.2:
                Ghost.ghosts.remove(self)
                uh.play()
                Sanity.sanity -= 25
                self.kill()

        self.rect.centerx = round(self.pos[0],0)
        self.rect.centery = round(self.pos[1],0)
        self.rectSmall.centerx = round(self.pos[0],0)
        self.rectSmall.centery = round(self.pos[1],0)

###################### HLAVNÁ POSTAVA ######################

class Character(pygame.sprite.Sprite):
    images = []
    human = True
    dx = 0.0
    dy = 0.0
    Ainterval = 0.06
    Sinterval = 0
    rect = Rect((0, 0, 10, 10))
    
    def __init__(self, startpos = (50.0, 350.0)):
       pygame.sprite.Sprite.__init__(self, self.groups)
       self.pos = [0.0, 0.0]
       self.pos[0] = startpos[0] * 1.0
       self.pos[1] = startpos[1] * 1.0
       self.image = Character.images[0]
       self.rect = self.image.get_rect()
       self.rect = self.rect.inflate(-10, 0)
       self.rect.centerx = round(self.pos[0],0)
       self.rect.centery = round(self.pos[1],0)
       Character.rect = self.rect
       self.rectSmall = self.rect.inflate(-15, -90)
       self.rectSmall.centerx = round(self.pos[0],0)
       self.rectSmall.centery = round(self.pos[1],0)+40
            
    def update(self, sec):
        self.rectSmall.centerx += self.dx//20
        self.rectSmall.centery += self.dy//20
        
        if self.rectSmall.collidelist(Wall.rects + Door.rects + Portal.rects) == -1:
            self.Sinterval += sec
            self.Ainterval += sec
            if self.Ainterval > 0.05:
                if Character.human:
                    state = self.images.index(self.image) % 8 + 1
                    if state >= 8:
                        state = 0
                    if self.dy > 0:
                        self.image = self.images[state]
                    elif self.dy < 0:
                        self.image = self.images[8+state]
                    elif self.dx > 0:
                        self.image = self.images[24+state]
                    elif self.dx < 0:
                        self.image = self.images[16+state]
                    else:
                        self.image = self.images[0]
                        self.Sinterval = 0
                else:
                    if self.dy > 0:
                        self.image = self.images[35]
                    elif self.dy < 0:
                        self.image = self.images[32]
                    elif self.dx > 0:
                        self.image = self.images[34]
                    elif self.dx < 0:
                        self.image = self.images[33]
                    else:
                        self.image = self.images[35]
                self.Ainterval = 0
                
            if self.Sinterval > 0.05 and (self.dy != 0 or self.dx != 0) and Character.human:
                step.play()
                self.Sinterval = -0.3
            
            self.pos[0] += self.dx * sec
            self.pos[1] += self.dy * sec
        else:
            if Character.human:
                self.image = self.images[0]
            else:
                self.image = self.images[32]

        self.dx = 0
        self.dy = 0
        
        self.rect.centerx = round(self.pos[0],0)
        self.rect.centery = round(self.pos[1],0)
        self.rectSmall.centerx = round(self.pos[0],0)
        self.rectSmall.centery = round(self.pos[1],0)+40

###################### PRÁZDNE TELO HLAVNEJ POSTAVY ######################

class Corpse(pygame.sprite.Sprite):
    images = []
    corpses = []
    rects = []
    end = [0.0, 0.0]
    
    def __init__(self, startpos):
       pygame.sprite.Sprite.__init__(self, self.groups)
       self.pos = [0.0, 0.0]
       self.pos[0] = startpos[0]
       self.pos[1] = startpos[1]+30
       self.image = Corpse.images[0]
       self.rect = self.image.get_rect()
       self.rectSmall = self.rect.inflate(-100, -90)
       self.rect.centerx = round(self.pos[0],0)
       self.rect.centery = round(self.pos[1],0)
       self.rectSmall.centerx = round(self.pos[0],0)
       self.rectSmall.centery = round(self.pos[1],0)-10
       Corpse.end = (self.pos[0]+20, self.pos[1]+20)
       Corpse.corpses.append(self)
       Corpse.rects.append(self.rect)
       
    def update(self, sec):
        if self.rectSmall.colliderect(Character.rect):
            self.image = Corpse.images[1]
        else:
            self.image = Corpse.images[0]

###################### CYKLUS V HLAVNOM MENU ######################

def menu():
    global startlvl
    pygame.mixer.music.load(os.path.join('sounds', 'hudba.wav'))
    pygame.mixer.music.queue("sounds/hudba.wav")
    playM()
    fadeIN(BGmenu)
    tutorial = False
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return False
            elif event.type == pygame.MOUSEBUTTONDOWN:
                if event.button == 1:
                    if event.pos[0] > 265 and event.pos[0] < 480 and event.pos[1] > 285 and event.pos[1] < 325 and not(tutorial):
                        click.play()
                        pygame.mixer.music.fadeout(200)
                        fadeOUT(BGmenu)
                        return True
                    elif event.pos[0] > 265 and event.pos[0] < 480 and event.pos[1] > 350 and event.pos[1] < 390 and not(tutorial):
                        click.play()
                        startlvl = 0
                        Sanity.sanity = 250
                        file = open("checkpoint.txt","w")
                        file.write( "checkpoint = 0\n")
                        file.write( "sanity = 250\n")
                        file.close()
                        pygame.mixer.music.fadeout(200)
                        fadeOUT(BGmenu)
                        return True
                    elif event.pos[0] > 265 and event.pos[0] < 480 and event.pos[1] > 410 and event.pos[1] < 455 and not(tutorial):
                        screen.blit(BGtutorial, (0, 0))
                        pygame.display.flip()
                        tutorial = True
                    elif event.pos[0] > 60 and event.pos[0] < 205 and event.pos[1] > 455 and event.pos[1] < 495 and tutorial:
                        screen.blit(BGmenu, (0, 0))
                        pygame.display.flip()
                        tutorial = False
                    elif event.pos[0] > 265 and event.pos[0] < 480 and event.pos[1] > 470 and event.pos[1] < 510 and not(tutorial):
                        pygame.mixer.music.fadeout(200)
                        return False

###################### CYKLUS PO DOKONČENÍ HRY ######################

def ending():
    global restart
    alles.empty()
    front.empty()
    if Sanity.sanity > 0:
        fadeIN(BGend2)
        while True:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    return False
                elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1 and event.pos[0] > 255 and event.pos[0] < 475 and event.pos[1] > 480 and event.pos[1] < 525:
                    restart = True
                    file = open("checkpoint.txt","w")
                    file.write("checkpoint = 0\n")
                    file.write("sanity = 250\n")
                    file.close()
                    return False
    else:
        fadeIN(BGend)
        while True:
            for event in pygame.event.get():
                if event.type == pygame.QUIT:
                    return False
                elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1:
                    if event.button == 1 and event.pos[0] > 455 and event.pos[0] < 670 and event.pos[1] > 495 and event.pos[1] < 535:
                        restart = True
                        file = open("checkpoint.txt","w")
                        file.write("checkpoint = 0\n")
                        file.write("sanity = 250\n")
                        file.close()
                        return False
                    elif event.button == 1 and event.pos[0] > 65 and event.pos[0] < 280 and event.pos[1] > 495 and event.pos[1] < 535:
                        file = open("checkpoint.txt","w")
                        file.write("checkpoint = 11\n")
                        file.write("sanity = 250\n")
                        file.close()
                        Sanity.sanity = 250
                        return True

###################### ANIMÁCIA NA ZAČIATKU HRY ######################

def animation():

    pygame.mixer.music.load(os.path.join('sounds', 'party.wav'))
    pygame.mixer.music.queue("sounds/party.wav")
    playM()
    fadeIN(BGlvl)

    black = pygame.Surface((screen.get_size()))
    black.fill((0,0,0))
    black = black.convert()
    
    story = 0
    Text.texts.append(Text((430, 480), (255, 255, 255), "Táto Halloweenská párty je ešte lepšia ako tá minuloročná, Alex.", 7, 4))
    text = Text.texts[-1]
    
    while True:
        
        milisec = clock.tick(FPS)
        sec = milisec / 1000.0

        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                return False
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1 and event.pos[0] > 640 and event.pos[0] < 710 and event.pos[1] > 500 and event.pos[1] < 530:
                click.play()
                alles.empty()
                front.empty()
                pygame.mixer.music.fadeout(200)
                fadeOUT(black)
                return True

        if not(text.alive()):
            if story == 0:
                Text.texts.append(Text((520, 480), (150, 150, 150), "Vieš, trik je v tom vybrať si spávne miesto.", 4.5, 3))
            elif story == 1:
                Text.texts.append(Text((425, 480), (150, 150, 150), "Halloweenská párty v starom opustenom sídle? Zaručený úspech!", 5.5, 4))
            elif story == 2:
                Text.texts.append(Text((405, 480), (150, 150, 150), "Dokonca sa tu údajne usídlili duchovia. Jednoducho perfektné miesto!", 5.5, 4))
            elif story == 3:
                Text.texts.append(Text((470, 480), (255, 255, 255), "Dobre, ale s výzdobou muselo byť strašne veľa práce.", 5, 3))
            elif story == 4:
                Text.texts.append(Text((500, 480), (255, 255, 255), "A to ani nehovorím o tých špeciálnych efektoch!", 4.5, 3))
            elif story == 5:
                Text.texts.append(Text((595, 480), (150, 150, 150), "Aké špeciálne efekty myslíš?", 3.5, 3))
            elif story == 6:
                Text.texts.append(Text((585, 480), (255, 255, 255), "No, tie super strašidelné hlasy.", 3.5, 3))
            elif story == 7:
                Text.texts.append(Text((425, 480), (150, 150, 150), "Ja som žiadne hlasy neinštalovala. Asi si z teba niekto vystrelil.", 5.5, 4))
            elif story == 8:
                Text.texts.append(Text((500, 480), (255, 255, 255), "Ale veď sú tu všade! Počkaj... ty ich nepočuješ?", 4.5, 3))
            elif story == 9:
                Text.texts.append(Text((680, 480), (180, 0, 0), "Aaaaaaa!", 2, 1))
                aaa.play()
                for i in range(1,7):
                    screen.blit(black, (0,0))
                    alles.update(sec)
                    front.draw(screen)
                    pygame.display.flip()
                    
                    pygame.time.wait(i*50)

                    screen.blit(BGlvl, (0,0))
                    alles.update(sec)
                    alles.draw(screen)
                    front.draw(screen)
                    pygame.display.flip()

                    pygame.time.wait(round(500/i))
                pygame.time.wait(500)
                pygame.mixer.music.fadeout(200)
            elif story == 10:
                Text.texts.append(Text((670, 480), (180, 0, 0), "Čo to-?! AU!", 1, 1))
                text = Text.texts[-1]
                pygame.time.wait(2000)
                uh.play()
                for i in range(70):
                    alles.update(sec)
                    screen.blit(black, (0,0))
                    front.draw(screen)
                    pygame.display.flip()
                    pygame.time.wait(20) 
                pygame.time.wait(4000)  
            else:
                alles.empty()
                front.empty()
                fadeOUT(black)
                return True
            if len(Text.texts) > 0:
                text = Text.texts[-1]
            story += 1

        alles.update(sec)
        if story < 10:
            alles.clear(screen, BGlvl)
            alles.draw(screen)
        else:
            screen.blit(black, (0,0))
        front.draw(screen)
        pygame.display.flip()

#######################################################################
###################### CYKLUS POČAS HRANIA LEVLU ######################
#######################################################################

def play(character, sanity, hintbut, corpse):

###################### VYPÍSANIE TEXTU NA ZAČIATKU LEVLU ######################

    if not(Character.human):
        if Ghost.Ginterval < 3:
            Text.texts.append(Text((500, 485), (255, 255, 255), "Už zase...? Ó NIE! Duchovia sú extrémne podráždení!", 6, 3))
            Ginterval = -4
            Gspawn = True
        else:
            Gspawn = False
            Text.texts.append(Text((590, 455), (255, 255, 255), "Uh... Čo sa stalo s mojím telom?", 4, 3))
    else:
        Gspawn = True
    if Door.doors[-1].hurt:
        Text.texts.append(Text((410, 485), (255, 255, 255), "Ďelica miestnosť. V tomto dome by sa mi tipovanie mohlo vymstiť...", 6, 4))
    if len(Hole.holes)>0:
        Text.texts.append(Text((600, 485), (255, 255, 255), "Už som takmer pri východe.", 4, 2))

###################### RESETOVANIE PREMENNÝCH ######################

    global pressed
    pressed = []
    Ginterval = 0.0
    SGinterval = 0.5

###################### CYKLUS HRY ######################

    while True:

###################### ČAS OD POSLEDNÉHO BEHU CYKLU ######################

        milisec = clock.tick(FPS)
        sec = milisec / 1000.0

###################### NAČÍTAVANIE VSTUPOV ######################

        for event in pygame.event.get():

###################### ZRUŠENIE HRY ######################

            if event.type == pygame.QUIT:
                return False
            
###################### OTVÁRANIE OKNA S OVLÁDANÍM ######################
            
            elif event.type == pygame.MOUSEBUTTONDOWN and event.button == 1 and event.pos[0] > 640 and event.pos[0] < 710 and event.pos[1] > 500 and event.pos[1] < 530:
                click.play()
                front.remove(hintbut)
                front.add(hintbut)
                sec = hintbut.hinting()
                clock.tick(FPS)

###################### PREMENA NA / Z DUCHA ######################

            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_q:
                    if Character.human:
                        transform.play()
                        corpse = Corpse(character.pos)
                        alles.remove(character)
                        alles.add(character)
                        Character.human = False
                        Text.texts.append(Text((550, 455), (180, 0, 0), "Duchovia chcú obsadiť prázdne telo!", 3.5, 3))
                    elif len(Corpse.corpses) > 0 and corpse.rectSmall.colliderect(Character.rect):
                        transform.play()
                        if not(Gspawn):
                            Gspawn = True
                            Text.texts.append(Text((550, 485), (255, 255, 255), "Ja... žijem? Musím sa odtiaľto dostať!", 4.5, 3))
                        Character.human = True
                        Corpse.rects = []
                        corpse.kill()

###################### INTERAKCIA S DVERAMI ######################
                        
                elif event.key == pygame.K_e:
                    if len(Door.doors) > 0:
                        if character.rect.collidelist(Door.rectsB) != -1 or character.rectSmall.collidelist(Door.rectsB) != -1:
                            if character.rect.collidelist(Door.rectsB) != -1:
                                collidi = character.rect.collidelist(Door.rectsB)
                            else:
                                collidi = character.rectSmall.collidelist(Door.rects)
                            if Character.human:
                                if Door.doors[collidi].openable:
                                    door.play()
                                    if Door.doors[collidi].escape:
                                        return True
                                    elif Door.doors[collidi].hurt:
                                        Sanity.sanity -= 63
                                        Text.texts.append(Text((620, 425), (180, 0, 0), "AU! Tak tade nie...", 2.5, 1))
                                    elif Door.images.index(Door.doors[collidi].image) < 2:
                                        if Door.doors[collidi].pos[0] > character.pos[0]:
                                            character.pos[0] += 100
                                        else:
                                            character.pos[0] -= 100
                                    else:
                                        if Door.doors[collidi].pos[1] > character.pos[1]:
                                            character.pos[1] += 135
                                        else:
                                            character.pos[1] -= 140
                                elif not(Door.doors[collidi].secret):
                                    if Door.doors[collidi].code == True:
                                        Slocked.play()
                                        Text.texts.append(Text((430, 425), (180, 0, 0), "Zadaj kód = určité 4 znaky stlačené v ľubovoľnom poradí + E.", 4, 4))
                                    else:
                                        Slocked.play()
                                        Text.texts.append(Text((680, 425), (180, 0, 0), "Zamknuté", 1.5, 1))
                                else:
                                    Slocked.play()
                            elif not(Door.doors[collidi].secret):
                                Text.texts.append(Text((620, 425), (180, 0, 0), "Nutná fyzická forma", 1.5, 1))

###################### INTERAKCIA S PORTÁLMI ######################
   
                    if len(Portal.portals) > 0 and not(Character.human):
                        if character.rect.collidelist(Portal.rectsB) != -1 or character.rectSmall.collidelist(Portal.rectsB) != -1:
                            Sportal.play()
                            if character.rect.collidelist(Portal.rectsB) != -1:
                                collidi = character.rect.collidelist(Portal.rectsB)
                            else:
                                collidi = character.rectSmall.collidelist(Portal.rects)
                            if Portal.images.index(Portal.portals[collidi].image) < 2:
                                if Portal.portals[collidi].pos[1] > character.pos[1]:
                                    character.pos[1] += 135
                                else:
                                    character.pos[1] -= 140
                            else:
                                if Portal.portals[collidi].pos[0] > character.pos[0]:
                                    character.pos[0] += 100
                                else:
                                    character.pos[0] -= 100

###################### INTERAKCIA SO ZÁMKAMI ######################

                    if len(Lock.locks) > 0:
                        if character.rect.collidelist(Lock.rects) != -1 or character.rectSmall.collidelist(Lock.rects) != -1:
                            click.play()
                            locki = character.rect.collidelist(Lock.locks)
                            Lock.locks[locki].on = not(Lock.locks[locki].on)
                            for locked in Lock.locks[locki].doori:
                                Door.doors[locked].openable = not(Door.doors[locked].openable)

###################### ODRÁŽANIE DUCHOV ######################

                if not(Character.human) and len(Ghost.ghosts) > 0:
                    for button in range(len(butfree)):
                        if event.key == butfree[button]:
                            for ghost in Ghost.marked[button]:
                                ghost.kill()

###################### STLAČENÉ KLÁVESY (potrebné ak sú v levli dvere na kód) ######################

                if Door.doors[-1].code and not(Door.doors[-1].openable):
                    pressed += [event.key]

###################### NASTAVENIE SMERU POHYBU ######################

        keys = pygame.key.get_pressed()
        if keys[K_w]:
            character.dy = -120
        elif keys[K_s]:
            character.dy = 120
        elif keys[K_a]:
            character.dx = -150
        elif keys[K_d]:
            character.dx = 150

###################### SPAWN A ZVUKY DUCHOV ######################

        if not(Character.human):
            SGinterval += sec * random.randint(1, 3)
            if Gspawn:
                Ginterval += sec
    
        if Ginterval > Ghost.Ginterval:
            if random.randint(0, 1) == 1:
                x = random.randint(-360, 1080)
                y = 580 * random.choice((-1, 1))
            else:
                x = 760 * random.choice((-1, 1))
                y = random.randint(-270, 810)
            Ghost((x, y), random.randint(0, 5))
            Ginterval = 0

        if SGinterval > Ghost.Ginterval*4:
            soundi = random.randint(0,len(Ghost.FreeS)-1)
            Ghost.FreeS[soundi].play()
            Ghost.UsedS.append(Ghost.FreeS[soundi])
            Ghost.FreeS.remove(Ghost.FreeS[soundi])
            if len(Ghost.FreeS) < 1:
                Ghost.FreeS = Ghost.UsedS.copy()
                Ghost.UsedS = []
            SGinterval = 0.0

###################### PREHRA ######################

        if Sanity.sanity <= 0:
            dead.play()
            return True

###################### UPDATE A VYKRESĽOVANIE ######################

        alles.clear(screen, BGlvl)
        alles.update(sec)
        alles.draw(screen)

        if not(Character.human):
            screen.blit(white, (0,0))

        front.remove(sanity)
        front.add(sanity)

        front.draw(screen)
        
        pygame.display.flip()

        if Hole.escape:
            Hole.escape = Hole.holes[-1].fall()
            return True

######################################################################
###################### CYKLUS SPÚŠŤANIA LEVELOV ######################
######################################################################

def mainloop(startlvl):
    mainloop = True
    lvlnumber = startlvl
    checkpoint = startlvl
    fade = pygame.Surface((screen.get_size()))
    fade.fill((0,0,0))
    
    while mainloop:

        alles.empty()
        front.empty()

        sanity = None
        character = None
        sight = None
        hint = None
        hole = None
        Ghost.Ginterval = 3.5
        Hole.holes = []
        Decoration.decorations = []
        Wall.walls = []
        Wall.rects = []
        Corpse.corpses = []
        Door.doors = []
        Door.rects = []
        Door.rectsB = []
        Lock.locks = []
        Lock.rects = []
        Text.texts = []
        Portal.portals = []
        Portal.rects = []
        Portal.rectsB = []
        Ghost.ghosts = []
        Ghost.marked = [[], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], []]

        screen.blit(BGlvl, (0, 0))

###################### GENEROVANIE PROSTREDIA ANIMÁCIE ######################

        if lvlnumber == 0:
            
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 10 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 10 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(13):
                Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 20 + Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([650 + Wall.images[0].get_size()[0]/2, 20 + Wall.images[0].get_size()[0]/2], 0))
            
            for i in range(11):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(11):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Decoration.decorations.append(Decoration([130, 50], 9, 0, 0))
            Decoration.decorations.append(Decoration([250, 50], 9, 0, 0))
            Decoration.decorations.append(Decoration([465, 50], 9, 0, 0))
            Decoration.decorations.append(Decoration([585, 50], 9, 0, 0))

            Door.doors.append(Door((360, 50), 1, False, False))
            
            Decoration.decorations.append(Decoration((60, 380), 22, 0, 0))
            Decoration.decorations.append(Decoration((660, 380), 21, 0, 0))
            Decoration.decorations.append(Decoration((60, 80), 21, 0, 0))
            Decoration.decorations.append(Decoration((660, 80), 22, 0, 0))

            Decoration.decorations.append(Decoration((200, 210), 19, 0, 0))
            Decoration.decorations.append(Decoration((500, 310), 19, 0, 0))

            Decoration.decorations.append(Decoration((160, 190), 23, 0, 0))
            Decoration.decorations.append(Decoration((250, 195), 23, 0, 0))
            Decoration.decorations.append(Decoration((530, 290), 23, 0, 0))
            Decoration.decorations.append(Decoration((540, 295), 24, 0, 0))
            Decoration.decorations.append(Decoration((520, 300), 23, 110, 0))
            Decoration.decorations.append(Decoration((170, 195), 24, 0, 0))
            Decoration.decorations.append(Decoration((210, 200), 25, 0, 0))
            Decoration.decorations.append(Decoration((480, 300), 25, 0, 0))

            Decoration.decorations.append(Decoration((430, 343), 11, 0, 0))
            Decoration.decorations.append(Decoration((447, 337), 12, 0, 0))
            Decoration.decorations.append(Decoration((400, 80), 13, 0, 0))
            Decoration.decorations.append(Decoration((320, 80), 13, 0, 0))
            Decoration.decorations.append(Decoration((655, 115), 11, 0, 0))
            Decoration.decorations.append(Decoration((70, 405), 14, 0, 0))

            Decoration.decorations.append(Decoration((90, 180), 0, 0, 0))
            Decoration.decorations.append(Decoration((270, 280), 2, 0, 0))
            Decoration.decorations.append(Decoration((315, 330), 1, 0, 0))
            Decoration.decorations.append(Decoration((225, 330), 3, 0, 0))
            Decoration.decorations.append(Decoration((590, 280), 5, 0, 0))
            Decoration.decorations.append(Decoration((500, 150), 4, 0, 0))
            Decoration.decorations.append(Decoration((430, 140), 6, 0, 0))

            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 500 - Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 500 - Wall.images[1].get_size()[1]/2], 1))
            for i in range(13):
                Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 490 - Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([657 + Wall.images[0].get_size()[0]/2, 490 - Wall.images[0].get_size()[0]/2], 0))

            mainloop = animation()
            lvlnumber = 1
            Door.doors = []

        corpse = None
        Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 10 + Wall.images[1].get_size()[1]/2], 1))
        Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 10 + Wall.images[1].get_size()[1]/2], 1))
        for i in range(13):
            Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 20 + Wall.images[0].get_size()[0]/2], 0))
        Wall.walls.append(Wall([650 + Wall.images[0].get_size()[0]/2, 20 + Wall.images[0].get_size()[0]/2], 0))

###################### GENEROVANIE PROSTREDIA LVL 1 ######################

        if lvlnumber == 1:
            for i in range(11):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(11):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            
            Decoration.decorations.append(Decoration([130, 50], 10, 0, 0))
            Decoration.decorations.append(Decoration([250, 50], 10, 0, 0))
            Decoration.decorations.append(Decoration([465, 50], 10, 0, 0))
            Decoration.decorations.append(Decoration([585, 50], 10, 0, 0))

            Door.doors.append(Door((360, 50), 1, False, True))

            Decoration.decorations.append(Decoration((60, 80), 21, 0, 0))
            Decoration.decorations.append(Decoration((660, 80), 22, 0, 0))
            
            corpse = Corpse((600, 300))

            Decoration.decorations.append(Decoration((578, 348), 15, 0, 0))
            Decoration.decorations.append(Decoration((645, 340), 16, 0, 0))
            Decoration.decorations.append(Decoration((400, 80), 17, 0, 0))
            Decoration.decorations.append(Decoration((320, 80), 17, 0, 0))
            Decoration.decorations.append(Decoration((655, 115), 15, 0, 0))
            Decoration.decorations.append(Decoration((70, 405), 18, 90, 0))

            Decoration.decorations.append(Decoration((160, 190), 23, 70, 0))
            Decoration.decorations.append(Decoration((250, 195), 23, -80, 0))
            Decoration.decorations.append(Decoration((380, 340), 23, -100, 0))
            Decoration.decorations.append(Decoration((300, 360), 24, 90, 0))
            Decoration.decorations.append(Decoration((600, 200), 23, -80, 0))
            Decoration.decorations.append(Decoration((540, 295), 24, 180, 0))
            Decoration.decorations.append(Decoration((520, 300), 23, 110, 0))
            
            character = Character([120, 350])
            Character.human = False
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

            pygame.mixer.music.load(os.path.join('sounds', 'hudba.wav'))
            pygame.mixer.music.queue("sounds/hudba.wav")

###################### GENEROVANIE PROSTREDIA LVL 2 ######################

        elif lvlnumber == 2:
            for i in range(4):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([185, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([360, 25 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 25 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([360, 45 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 45 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((360, 105), 0, False, False))
            Door.doors.append(Door((535, 105), 0, False, False))
            Wall.walls.append(Wall([360, 125 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 125 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(4):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 150 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 150 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(13):
                Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 160 + Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([650 + Wall.images[0].get_size()[0]/2, 160 + Wall.images[0].get_size()[0]/2], 0))
                
            for i in range(4):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(8):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Wall.walls.append(Wall([185, 290 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 290 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(10):
                Wall.walls.append(Wall([180 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 300 + Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([705 - Wall.images[0].get_size()[0]/2, 300 + Wall.images[0].get_size()[0]/2], 0))

            Door.doors.append(Door((110, 190), 1, True, True))
            Lock.locks.append(Lock((675, 70), 1, [len(Door.doors)-1]))
            Door.doors.append(Door((440, 190), 1, False, False))
            Door.doors.append(Door((260, 330), 1, False, False))
            
            for i in range(4):
                Wall.walls.append(Wall([185, 305 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([360, 305 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 305 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([360, 315 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 315 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((360, 375), 0, False, False))
            Door.doors.append(Door((535, 375), 0, False, False))
            Wall.walls.append(Wall([360, 395 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 395 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(4):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 305 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Decoration.decorations.append(Decoration([270, 190], 10, 0, 0))
            Decoration.decorations.append(Decoration([580, 190], 10, 0, 0))
            Decoration.decorations.append(Decoration((670, 415), 15, 0, 0))
            Decoration.decorations.append(Decoration((270, 65), 20, 0, 0))

            character = Character([100, 350])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 3 ######################
        
        elif lvlnumber == 3:
            for i in range(4):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([360, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([535, 25 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((535, 85), 0, True, False))
            Wall.walls.append(Wall([535, 105 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(4):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            for i in range(7):
                Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 160 + Wall.images[0].get_size()[0]/2], 0))
            for i in range(3):
                Wall.walls.append(Wall([543 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 120 + Wall.images[0].get_size()[0]/2], 0))

            for i in range(4):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([360, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([185, 290 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([360, 320 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 125 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((535, 185), 0, True, False))
            Lock.locks.append(Lock((80, 50), 0, [len(Door.doors)-1]))
            Wall.walls.append(Wall([535, 205 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 235 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 275 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(5):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 125 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            for i in range(3):
                Wall.walls.append(Wall([185 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 300 + Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([319 + Wall.images[0].get_size()[0]/2, 300 + Wall.images[0].get_size()[0]/2], 0))
            for i in range(3):
                Wall.walls.append(Wall([543 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 300 + Wall.images[0].get_size()[0]/2], 0))

            for i in range(4):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 305 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([185, 305 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([535, 305 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 325 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((535, 385), 0, True, False))
            Wall.walls.append(Wall([535, 405 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([535, 425 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(4):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 305 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Decoration.decorations.append(Decoration([240, 190], 10, 0, 0))

            Door.doors.append(Door((110, 190), 1, True, False))
            Door.doors.append(Door((300, 330), 1, True, False))
            Door.doors.append(Door((450, 50), 1, True, True))
            Lock.locks.append(Lock((675, 410), 1, [len(Door.doors)-1]))
            Portal.portals.append(Portal((185, 385), 1))
            Portal.portals.append(Portal((260, 185), 0))
            Portal.portals.append(Portal((620, 325), 0))

            Decoration.decorations.append(Decoration((50, 410), 16, 0, 0))
            Decoration.decorations.append(Decoration((250, 65), 26, 0, 0))
            
            character = Character([450, 370])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 4 ######################

        elif lvlnumber == 4:

            for i in range(5):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([530, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(8):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            for i in range(10):
                Wall.walls.append(Wall([25 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 160 + Wall.images[0].get_size()[0]/2], 0))

            for i in range(7):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([210, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([530, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
                
            Portal.portals.append(Portal((530, 280), 1))
                
            for i in range(10):
                Wall.walls.append(Wall([205 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 310 + Wall.images[0].get_size()[0]/2], 0))

            for i in range(4):
                Wall.walls.append(Wall([210, 315 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 315 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Door.doors.append(Door((110, 190), 1, True, False))
            Lock.locks.append(Lock((675, 160), 1, [len(Door.doors)-1]))
            Lock.locks.append(Lock((440, 190), 0, [4]))
            Door.doors.append(Door((310, 190), 1, False, False))
            Door.doors.append(Door((410, 330), 1, False, False))
            Door.doors.append(Door((610, 330), 1, False, False))
            Portal.portals.append(Portal((210, 190), 1))

            Decoration.decorations.append(Decoration((505, 90), 15, 0, 0))
            Decoration.decorations.append(Decoration([150, 50], 10, 0, 0))
            Decoration.decorations.append(Decoration([290, 50], 10, 0, 0))
            Decoration.decorations.append(Decoration([430, 50], 10, 0, 0))
            Decoration.decorations.append(Decoration((60, 60), 21, 0, 0))
            Decoration.decorations.append(Decoration((245, 370), 22, 0, 0))
            Decoration.decorations.append(Decoration((615, 70), 19, 0, 0))

            character = Character([120, 370])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 5 ######################

        elif lvlnumber == 5:
            
            for i in range(5):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            for i in range(13):
                Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 200 + Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([650 + Wall.images[0].get_size()[0]/2, 200 + Wall.images[0].get_size()[0]/2], 0))

            for i in range(7):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 205 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([185, 205 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([360, 205 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([535, 205 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 205 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Door.doors.append(Door((185, 385), 0, True, False))
            Wall.walls.append(Wall([185, 405 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((360, 385), 0, True, False))
            Wall.walls.append(Wall([360, 405 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((535, 385), 0, True, False))
            Wall.walls.append(Wall([535, 405 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((697, 385), 0, True, True))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 405 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 425 + Wall.images[1].get_size()[1]/2], 1))

            Portal.portals.append(Portal((110, 225), 0))

            Lock.locks.append(Lock((60, 50), 0, []))
            Lock.locks.append(Lock((160, 50), 0, [0, 1]))
            Lock.locks.append(Lock((260, 50), 0, [0]))
            Lock.locks.append(Lock((360, 50), 0, [0, 2]))
            Lock.locks.append(Lock((460, 50), 0, [0]))
            Lock.locks.append(Lock((560, 50), 0, [3]))
            Lock.locks.append(Lock((660, 50), 0, []))

            Decoration.decorations.append(Decoration([270, 235], 10, -10, 0))
            Decoration.decorations.append(Decoration((617, 250), 19, 0, 0))
            Decoration.decorations.append(Decoration((470, 255), 17, 0, 0))
            Decoration.decorations.append(Decoration((460, 400), 27, 10, -1))

            character = Character([100, 370])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 6 ######################
            
        elif lvlnumber == 6:

            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 65 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((23, 125), 0, True, False))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 145 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(5):
                Wall.walls.append(Wall([260, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([450, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 65 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((697, 125), 0, True, False))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 145 + Wall.images[1].get_size()[1]/2], 1))

            for i in range(5):
                Wall.walls.append(Wall([19 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 165 + Wall.images[0].get_size()[0]/2], 0))
            for i in range(5):
                Wall.walls.append(Wall([443 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 165 + Wall.images[0].get_size()[0]/2], 0))

            for i in range(4):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 170 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 170 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([260, 290 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([450, 290 + Wall.images[1].get_size()[1]/2], 1))

            for i in range(5):
                Wall.walls.append(Wall([19 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 300 + Wall.images[0].get_size()[0]/2], 0))
            for i in range(5):
                Wall.walls.append(Wall([443 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 300 + Wall.images[0].get_size()[0]/2], 0))

            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 305 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 345 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((23, 405), 0, True, False))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 425 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(5):
                Wall.walls.append(Wall([260, 305 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([450, 305 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 305 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 345 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((697, 405), 0, True, False))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 425 + Wall.images[1].get_size()[1]/2], 1))

            Portal.portals.append(Portal((100, 190), 0))
            Portal.portals.append(Portal((510, 190), 0))
            Portal.portals.append(Portal((260, 395), 1))
            Portal.portals.append(Portal((450, 405), 1))

            Door.doors.append(Door((360, 51), 1, True, True, secret = True))

            Lock.locks.append(Lock((195, 50), 0, [len(Door.doors)-1]))
            Lock.locks.append(Lock((620, 50), 0, [len(Door.doors)-1]))
            Lock.locks.append(Lock((130, 330), 0, [len(Door.doors)-1]))
            Lock.locks.append(Lock((590, 330), 0, [len(Door.doors)-1]))

            Decoration.decorations.append(Decoration((360, 44), 30, 0, 0))
            Decoration.decorations.append(Decoration((665, 210), 21, 0, 0))
            Decoration.decorations.append(Decoration((140, 195), 10, -10, 0))
            Decoration.decorations.append(Decoration((585, 200), 10, 17, 0))
            Decoration.decorations.append(Decoration((330, 70), 17, 0, -1))
            Decoration.decorations.append(Decoration((60, 220), 18, 0, 0))
            Decoration.decorations.append(Decoration((480, 355), 16, 0, 0))
            Decoration.decorations.append(Decoration((360, 270), 40, 0, -1))

            Portal.portals.append(Portal((100, 190), 0))
            Portal.portals.append(Portal((510, 190), 0))
            Portal.portals.append(Portal((260, 395), 1))
            Portal.portals.append(Portal((450, 405), 1))

            character = Character([360, 370])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 7 ######################
          
        elif lvlnumber == 7:

            Decoration.decorations.append(Decoration((85, 70), 36, 0, 0))
            for i in range(11):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([250, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([460, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(11):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            for i in range(4):
                Wall.walls.append(Wall([253+ Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 165 + Wall.images[0].get_size()[0]/2], 0))

            for i in range(4):
                Wall.walls.append(Wall([250, 170 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([250, 410 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([250, 370 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(7):
                Wall.walls.append(Wall([460, 170 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Door.doors.append(Door((250, 350), 0, True, False))
            Lock.locks.append(Lock((675, 70), 1, [len(Door.doors)-1]))
            Door.doors.append(Door((355, 200), 1, False, True, code = True))
            Portal.portals.append(Portal((460, 300), 1))

            Decoration.decorations.append(Decoration((580, 55), 35, 0, 0))
            Decoration.decorations.append(Decoration((85, 120), 37, 0, -1))
            Decoration.decorations.append(Decoration((360, 320), 39, 90, 0))
            Decoration.decorations.append(Decoration((362, 330), 38, 0, 0))
            Decoration.decorations.append(Decoration((665, 405), 18, -60, 0))
            Decoration.decorations.append(Decoration((50, 405), 16, 0, 0))
            Decoration.decorations.append(Decoration((215, 230), 21, 0, 0))
            Decoration.decorations.append(Decoration((415, 200), 31, 0, 0))

            Decoration.decorations.append(Decoration((610, 200), 23, -80, 0))
            Decoration.decorations.append(Decoration((540, 385), 24, 180, 0))
            Decoration.decorations.append(Decoration((520, 400), 23, 110, 0))

            character = Character([360, 370])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 8 ######################
          
        elif lvlnumber == 8:

            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 45 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((23, 105), 0, False, True))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 125 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((23, 185), 0, False, False, hurt = True))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 205 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((23, 265), 0, False, False, hurt = True))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 285 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((23, 345), 0, False, False, hurt = True))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 365 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 405 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 445 + Wall.images[1].get_size()[1]/2], 1))
            
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 45 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((697, 105), 0, False, False, hurt = True))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 125 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((697, 185), 0, False, False, hurt = True))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 205 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((697, 265), 0, False, False, hurt = True))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 285 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((697, 345), 0, False, False, hurt = True))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 365 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 405 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2710 - Wall.images[1].get_size()[0]/2, 445 + Wall.images[1].get_size()[1]/2], 1))

            Door.doors.append(Door((135, 50), 1, False, False, hurt = True))
            Door.doors.append(Door((225, 50), 1, False, False, hurt = True))
            Door.doors.append(Door((315, 50), 1, False, False, hurt = True))
            Door.doors.append(Door((405, 50), 1, False, False, hurt = True))
            Door.doors.append(Door((495, 50), 1, False, False, hurt = True))
            Door.doors.append(Door((585, 50), 1, False, False, hurt = True))

            Decoration.decorations.append(Decoration((360, 270), 32, 0, 1))
            Decoration.decorations.append(Decoration((360, 270), 33, 0, -1))

            character = Character([360, 370])
            sight = Sight(character.pos, 1)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 9 ######################

        elif lvlnumber == 9:

            for i in range(8):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(8):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(7):
                Wall.walls.append(Wall([160, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(7):
                Wall.walls.append(Wall([560, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            for i in range(13):
                Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 270 + Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([657 + Wall.images[0].get_size()[0]/2, 270 + Wall.images[0].get_size()[0]/2], 0))

            for i in range(4):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 275 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 275 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            Wall.walls.append(Wall([240, 275 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([240, 305 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((240, 365), 0, False, False))
            Wall.walls.append(Wall([240, 385 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([240, 395 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([470, 275 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([470, 305 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((470, 365), 0, False, False))
            Wall.walls.append(Wall([470, 385 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([470, 395 + Wall.images[1].get_size()[1]/2], 1))

            Door.doors.append(Door((360, 300), 1, True, False))
            Lock.locks.append(Lock((615, 410), 0, [len(Door.doors)-1]))
            Door.doors.append(Door((360, 50), 1, True, True))

            Decoration.decorations.append(Decoration((360, 120), 34, 0, 0, doori = len(Door.doors)-1))
            for i in range(8):
                for j in range(7):
                    Decoration.decorations.append(Decoration((50+i*20, 320+j*15), 17, 0, 0))
            Decoration.decorations.append(Decoration((670, 320), 8, 0, 0))
            Decoration.decorations.append(Decoration((290, 90), 7, 50, 0))
            Decoration.decorations.append(Decoration((440, 160), 7, -100, 0))
            Decoration.decorations.append(Decoration([250, 50], 10, 0, 0))
            Decoration.decorations.append(Decoration([465, 50], 10, 0, 0))
            Decoration.decorations.append(Decoration([185, 250], 15, 0, 0))

            character = Character([355, 365])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 10 ######################

        elif lvlnumber == 10:

            for i in range(5):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 200 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2,65 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((697, 125), 0, True, False))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 145 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 185 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 200 + Wall.images[1].get_size()[1]/2], 1))

            hole = Hole([460, 150])

            for i in range(13):
                Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 180 + Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([657 + Wall.images[0].get_size()[0]/2, 180 + Wall.images[0].get_size()[0]/2], 0))

            Decoration.decorations.append(Decoration((230, 55), 28, 0, 0))
            Decoration.decorations.append(Decoration((360, 55), 29, 0, 0))
            Decoration.decorations.append(Decoration((490, 55), 31, 0, 0))

            character = Character([100, 100])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### GENEROVANIE PROSTREDIA LVL 11 ######################

        elif lvlnumber == 11:

            for i in range(4):
                Wall.walls.append(Wall([50 + Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(4):
                Wall.walls.append(Wall([245, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(11):
                Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 25 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))

            corpse = Corpse((150, 100))
            
            Wall.walls.append(Wall([595, 150 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(11):
                Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 160 + Wall.images[0].get_size()[0]/2], 0))
            Wall.walls.append(Wall([537 + Wall.images[0].get_size()[0]/2, 160 + Wall.images[0].get_size()[0]/2], 0))
            
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 165 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 185 + Wall.images[1].get_size()[1]/2], 1))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 225 + Wall.images[1].get_size()[1]/2], 1))
            Door.doors.append(Door((23, 285), 0, False, True))
            Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 305 + Wall.images[1].get_size()[1]/2], 1))
            for i in range(7):
                Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 310 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
                
            for i in range(5):
                Wall.walls.append(Wall([195, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([395, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(5):
                Wall.walls.append(Wall([595, 165 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(6):
                Wall.walls.append(Wall([295, 260 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            for i in range(6):
                Wall.walls.append(Wall([495, 260 + Wall.images[1].get_size()[1]/2 + Wall.images[1].get_size()[1]*i], 1))
            
            Door.doors.append(Door((110, 190), 1, True, False))
            Lock.locks.append(Lock((172, 260), 1, [len(Door.doors)-1]))
            Portal.portals.append(Portal((245, 100), 1))

            Character.human = False
            Ghost.Ginterval = 1.4
            character = Character([150, 80])
            sight = Sight(character.pos)
            hintbut = HintBut()
            sanity = Sanity()

###################### DOKONČENÁ HRA ######################

        else:
            file = open("checkpoint.txt","w")
            file.write( "checkpoint = 0\n")
            file.write( "sanity = 250\n")
            file.close()
            fin.play()
            mainloop = ending()

###################### DODATOČNÉ GENEROVANIE PROSTREDIA ######################

        Wall.walls.append(Wall([10 + Wall.images[1].get_size()[0]/2, 500 - Wall.images[1].get_size()[1]/2], 1))
        Wall.walls.append(Wall([710 - Wall.images[1].get_size()[0]/2, 500 - Wall.images[1].get_size()[1]/2], 1))
        for i in range(650//Wall.images[0].get_size()[0]):
            Wall.walls.append(Wall([15 + Wall.images[0].get_size()[0]/2 + Wall.images[0].get_size()[0]*i, 490 - Wall.images[0].get_size()[0]/2], 0))
        Wall.walls.append(Wall([657 + Wall.images[0].get_size()[0]/2, 490 - Wall.images[0].get_size()[0]/2], 0))

        if lvlnumber == 4:
            Door.doors.append(Door((520, 470), 1, False, True))

        if not(pygame.mixer.music.get_busy()):
            playM()

###################### SPÚŠŤANIE LVL ######################

        if mainloop:
            alles.update(0)
            alles.draw(screen)
            if not(Character.human):
                screen.blit(white, (0,0))
            front.draw(screen)
            screen.blit(fade, (0,0))
            
            pygame.display.flip()
            
            fadeIN(BGlvl)

            clock.tick(FPS)
            mainloop = play(character, sanity, hintbut, corpse)

###################### DOKONČENÝ LVL / ZRUŠENÁ HRA ######################

        if mainloop:
            fadeOUT(BGlvl)

            character.kill()
            sight.kill()
            sanity.kill()
            hintbut.kill()

###################### ZMENA LEVLU A CHECKPOINTU ######################
    
        if Sanity.sanity > 0:
            if lvlnumber > checkpoint+3:
                checkpoint += 1
            lvlnumber += 1
            number = str(lvlnumber)
            san = str(Sanity.sanity)
            if mainloop:
                file = open("checkpoint.txt","w")
                file.write( "checkpoint = " + number + "\n")
                file.write( "sanity = " + san + "\n")
                file.close()
        elif Ghost.Ginterval > 2:
            end = endF.render("Psychotické zrútenie", True, (180, 0, 0))
            end = end.convert_alpha()
            screen.blit(end, (140, 210))
            end2 = casualF.render("Časť postupu sa stratila", True, (180, 0, 0))
            end2 = end2.convert_alpha()
            screen.blit(end2, (250, 295))
            pygame.display.flip()
            pygame.time.wait(5000)
            Sanity.sanity = 250
            Character.human = True
            lvlnumber = checkpoint
            if mainloop:
                file = open("checkpoint.txt","w")
                number = str(lvlnumber)
                san = str(Sanity.sanity)
                file.write( "checkpoint = " + number + "\n")
                file.write( "sanity = " + san + "\n")
                file.close()
        else:
            dead.play()
            mainloop = ending()

###################### PRÍPRAVA MERANIA ČASU ######################

clock = pygame.time.Clock()
time = 0
FPS = 30

###################### NAČÍTANIE OBRÁZKOV ######################

try:
    Character.images.append(pygame.image.load(os.path.join("images","scared3.png")))
    Character.images.append(pygame.image.load(os.path.join("images","scared4.png")))
    Character.images.append(pygame.image.load(os.path.join("images","scared5.png")))
    Character.images.append(pygame.image.load(os.path.join("images","scared4.png")))
    Character.images.append(pygame.image.load(os.path.join("images","scared3.png")))
    Character.images.append(pygame.image.load(os.path.join("images","scared2.png")))
    Character.images.append(pygame.image.load(os.path.join("images","scared1.png")))
    Character.images.append(pygame.image.load(os.path.join("images","scared2.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bscared3.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bscared4.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bscared5.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bscared4.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bscared3.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bscared2.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bscared1.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bscared2.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sscared3.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sscared4.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sscared5.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sscared4.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sscared3.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sscared2.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sscared1.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sscared2.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2scared3.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2scared4.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2scared5.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2scared4.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2scared3.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2scared2.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2scared1.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2scared2.png")))
    Character.images.append(pygame.image.load(os.path.join("images","ghost.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Sghost.png")))
    Character.images.append(pygame.image.load(os.path.join("images","S2ghost.png")))
    Character.images.append(pygame.image.load(os.path.join("images","Bghost.png")))
    
    Wall.images.append(pygame.image.load(os.path.join("images","wall.png")))
    Wall.images.append(pygame.image.load(os.path.join("images","Swall.png")))
    
    Corpse.images.append(pygame.image.load(os.path.join("images","corpse.png")))
    Corpse.images.append(pygame.image.load(os.path.join("images","corpseE.png")))
    
    Door.images.append(pygame.image.load(os.path.join("images","door2.png")))
    Door.images.append(pygame.image.load(os.path.join("images","door2E.png")))
    Door.images.append(pygame.image.load(os.path.join("images","door.png")))
    Door.images.append(pygame.image.load(os.path.join("images","doorE.png")))

    Portal.images.append(pygame.image.load(os.path.join("images","portal.png")))
    Portal.images.append(pygame.image.load(os.path.join("images","portalE.png")))
    Portal.images.append(pygame.image.load(os.path.join("images","wall.png")))
    Portal.images.append(pygame.image.load(os.path.join("images","portal2.png")))
    Portal.images.append(pygame.image.load(os.path.join("images","portal2E.png")))
    Portal.images.append(pygame.image.load(os.path.join("images","Swall.png")))
    
    Lock.images.append(pygame.image.load(os.path.join("images","lockON.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockONE.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockOFF.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockOFFE.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockON2.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockON2E.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockOFF2.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockOFF2E.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockON3.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockON3E.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockOFF3.png")))
    Lock.images.append(pygame.image.load(os.path.join("images","lockOFF3E.png")))

    Ghost.images.append(pygame.image.load(os.path.join("images","ghost13.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost12.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost11.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost12.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost13.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost14.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost15.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost14.png")))

    Ghost.images.append(pygame.image.load(os.path.join("images","ghost23.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost22.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost21.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost22.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost23.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost24.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost25.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost24.png")))

    Ghost.images.append(pygame.image.load(os.path.join("images","ghost33.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost32.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost31.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost32.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost33.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost34.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost35.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost34.png")))

    Ghost.images.append(pygame.image.load(os.path.join("images","ghost43.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost42.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost41.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost42.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost43.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost44.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost45.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost44.png")))

    Ghost.images.append(pygame.image.load(os.path.join("images","ghost53.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost52.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost51.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost52.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost53.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost54.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost55.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost54.png")))

    Ghost.images.append(pygame.image.load(os.path.join("images","ghost63.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost62.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost61.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost62.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost63.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost64.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost65.png")))
    Ghost.images.append(pygame.image.load(os.path.join("images","ghost64.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","dancer11.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer12.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer13.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer12.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer11.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer14.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer15.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer14.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","dancer21.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer22.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer23.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer22.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer21.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer24.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer25.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer24.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","dancer31.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer32.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer33.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer34.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer35.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer36.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer35.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer34.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer33.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer32.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","dancer43.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer42.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer41.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer42.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer43.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer44.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer45.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer44.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","dancer51.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer52.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer53.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer52.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","dancer61.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer62.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer63.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer62.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer61.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer64.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer65.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancer64.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","dancing1.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancing2.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancing3.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancing4.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancing3.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dancing2.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","leg1.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","corpse1.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","chain.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","chain2.png")))
    
    Decoration.images.append(pygame.image.load(os.path.join("images","pumpkin1.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pumpkin2.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pumpkin3.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pumpkin4.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pumpkin12.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pumpkin22.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pumpkin32.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pumpkin42.png")))

    Decoration.images.append(pygame.image.load(os.path.join("images","table.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","tableD.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","balloons1.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","balloons2.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","cupO.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","cupB.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","cupcakes.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","dravers.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","2456.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","picture1.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","picture2.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","picture3.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","picture4.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","ways.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","ways2.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pentagram.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","pentagram2.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","Bianca.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","Lenka.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","Veronika.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","Katka.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","carpet.png")))
    Decoration.images.append(pygame.image.load(os.path.join("images","4hint.png")))

    HintBut.images.append(pygame.image.load(os.path.join("images","hint.png")))
    HintBut.images.append(pygame.image.load(os.path.join("images","hintWin.png")))
    HintBut.images.append(pygame.image.load(os.path.join("images","hintWin2.png")))

    Hole.images.append(pygame.image.load(os.path.join("images","hole.png")))
    Hole.images.append(pygame.image.load(os.path.join("images","hole2.png")))
    Hole.images.append(pygame.image.load(os.path.join("images","hole3.png")))
    Hole.images.append(pygame.image.load(os.path.join("images","hole4.png")))
    Hole.images.append(pygame.image.load(os.path.join("images","hole5.png")))
    
    BGmenu = pygame.image.load(os.path.join("images","MENU.png"))
    BGlvl = pygame.image.load(os.path.join("images","floor.png"))
    BGtutorial = pygame.image.load(os.path.join("images","tutorial.png"))
    BGend = pygame.image.load(os.path.join("images","endscene.png"))
    BGend2 = pygame.image.load(os.path.join("images","endscene2.png"))
    
    Sight.images.append(pygame.image.load(os.path.join("images","sight.png")))
    Sight.images.append(pygame.image.load(os.path.join("images","sight2.png")))
except:
    raise UserWarning ("!CHYBA! Neviem nájsť obrázok/obrázky v priečinku 'images' :(")

###################### KONVERTOVANIE OBRÁZKOV ######################

for i in range(len(Character.images)):
    if i < 16:
        Character.images[i] = pygame.transform.scale(Character.images[i], (Character.images[i].get_width()//4, Character.images[i].get_height()//4))
    else:
        Character.images[i] = pygame.transform.scale(Character.images[i], (round(Character.images[i].get_width()/3.85), round(Character.images[i].get_height()/3.85)))
    Character.images[i] = Character.images[i].convert_alpha()

Wall.images[0] = Wall.images[0].convert_alpha()

Corpse.images[0] = pygame.transform.scale(Corpse.images[0], (round(Corpse.images[0].get_width()/4.5), round(Corpse.images[0].get_height()/4.5)))
Corpse.images[1] = pygame.transform.scale(Corpse.images[1], (round(Corpse.images[1].get_width()/4.5), round(Corpse.images[1].get_height()/4.5)))
Corpse.images[0] = Corpse.images[0].convert_alpha()
Corpse.images[1] = Corpse.images[1].convert_alpha()

for i in range(len(Door.images)):
    Door.images[i] = Door.images[i].convert_alpha()
for i in range(len(Portal.images)):
    Portal.images[i] = Portal.images[i].convert_alpha()
for i in range(len(Lock.images)):
    Lock.images[i] = Lock.images[i].convert_alpha()
for i in range(len(Decoration.images)):
    if i < 54:
        Decoration.images[i] = pygame.transform.scale(Decoration.images[i], (Decoration.images[i].get_width()//4, Decoration.images[i].get_height()//4))
    Decoration.images[i] = Decoration.images[i].convert_alpha()
for i in range(len(Ghost.images)):
    Ghost.images[i] = pygame.transform.scale(Ghost.images[i], (Ghost.images[i].get_width()//4, Ghost.images[i].get_height()//4))
    Ghost.images[i] = Ghost.images[i].convert_alpha()

Sight.images[0] = Sight.images[0].convert_alpha()
Sight.images[1] = Sight.images[1].convert_alpha()

HintBut.images[0].convert_alpha()
HintBut.images[1].convert_alpha()

###################### NAČÍTANIE ZVUKOV ######################

try:
    pygame.mixer.music.load(os.path.join('sounds', 'hudba.wav'))
    pygame.mixer.music.load(os.path.join('sounds', 'party.wav'))
    door = pygame.mixer.Sound(os.path.join('sounds','dvere.wav'))
    click = pygame.mixer.Sound(os.path.join('sounds','klik.wav'))
    step = pygame.mixer.Sound(os.path.join('sounds','kroky.wav'))
    Slocked = pygame.mixer.Sound(os.path.join('sounds','locked.wav'))
    fire = pygame.mixer.Sound(os.path.join('sounds','fire.wav'))
    pip = pygame.mixer.Sound(os.path.join('sounds','pip.wav'))
    dead = pygame.mixer.Sound(os.path.join('sounds','tum.wav'))
    transform = pygame.mixer.Sound(os.path.join('sounds','transform.wav'))
    Sportal = pygame.mixer.Sound(os.path.join('sounds','portal.wav'))
    aaa = pygame.mixer.Sound(os.path.join('sounds','aaa.wav'))
    hole = pygame.mixer.Sound(os.path.join('sounds','hole.wav'))
    uh = pygame.mixer.Sound(os.path.join('sounds','uh.wav'))
    fin = pygame.mixer.Sound(os.path.join('sounds','fin.wav'))
    
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF1.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF2.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF3.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF4.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF5.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF6.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF7.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF8.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF9.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF10.wav')))
    Ghost.FreeS.append(pygame.mixer.Sound(os.path.join('sounds','voiceF11.wav')))
except:
    raise UserWarning ("!CHYBA! Neviem nájsť zvuk/zvuky v priečinku 'sounds' :(")

###################### HLASITOSŤ HUDBY ######################

volume = 0.2

###################### ZNAKY VHODNÉ NA ZAHÁŇANIE DUCHOV ######################

letters = "BCFGHIJKLMNOPRTUVXYZ"
butfree = [pygame.K_b, pygame.K_c, pygame.K_f, pygame.K_g,
           pygame.K_h, pygame.K_i, pygame.K_j, pygame.K_k,
           pygame.K_l, pygame.K_m, pygame.K_n, pygame.K_o,
           pygame.K_p, pygame.K_r, pygame.K_t, pygame.K_u,
           pygame.K_v, pygame.K_x, pygame.K_y, pygame.K_z]

###################### SKUPINY ######################

alles = pygame.sprite.Group()
front = pygame.sprite.Group()

Character.groups = alles
Wall.groups = alles
Corpse.groups = alles
Door.groups = alles
Lock.groups = alles
Hole.groups = alles
Portal.groups = alles
Decoration.groups = alles
Text.groups = alles, front
Sight.groups = alles, front
Sanity.groups = alles, front
Ghost.groups = alles, front
HintBut.groups = alles, front

###################### POZADIA ######################

white = pygame.Surface((screen.get_size()))
white.fill((235,235,255))
white.set_alpha(70)

BGend = BGend.convert_alpha()
BGend2 = BGend2.convert_alpha()
BGlvl = BGlvl.convert_alpha()
BGmenu = BGmenu.convert_alpha()
screen.blit(BGmenu, (0, 0))

###################### FULLSCREEN VYPNUTÝ ######################

fullscreen = False

###################### NAČÍTANIE ULOŽENÉHO POSTUPU ######################

try:
    file = open("checkpoint.txt","r")
    line  = file.readline().split()
    startlvl = int(line[2])
    line  = file.readline().split()
    Sanity.sanity = int(line[2])
    file.close()
except:
    raise UserWarning ("!CHYBA! Neviem problém s textovým súborom :(")

###################### SPUSTENIE / REŠTART HRY ######################

restart = True
while restart:
    restart = False
    screen.blit(BGmenu, (0, 0))
    pygame.display.flip()
    start = menu()
    if start:
        mainloop(startlvl)
        
        alles.empty()
        front.empty()
        
        sanity = None
        character = None
        sight = None
        hint = None
        hole = None
        Ghost.Ginterval = 3.5
        Hole.holes = []
        Decoration.decorations = []
        Wall.walls = []
        Wall.rects = []
        Corpse.corpses = []
        Door.doors = []
        Door.rects = []
        Door.rectsB = []
        Lock.locks = []
        Lock.rects = []
        Text.texts = []
        Portal.portals = []
        Portal.rects = []
        Portal.rectsB = []
        Ghost.ghosts = []
        Ghost.marked = [[], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], [], []]

        Sanity.sanity = 250

###################### KONIEC PROGRAMU ######################

pygame.quit()
pygame.font.quit()
pygame.mixer.quit()
